# Yarn.Saliency Namespace

## Summary

Contains classes for choosing the most relevant content out of a set of possible options.

## Classes

| Name                                                                                                                                      | Description                                                                                                                                                |
| ----------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [BestLeastRecentlyViewedSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.bestleastrecentlyviewedsaliencystrategy.md)             | A content saliency strategy that returns the first of the best, least-recently seen choices from the provided options.                                     |
| [BestSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.bestsaliencystrategy.md)                                                   | A content saliency strategy that returns the best of the provided options.                                                                                 |
| [ContentSaliencyOption](/api/csharp/yarn.saliency/yarn.saliency.contentsaliencyoption.md)                                                 | Represents a piece of content that may be selected by an [IContentSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.icontentsaliencystrategy.md) . |
| [EnumerableRandomExtension](/api/csharp/yarn.saliency/yarn.saliency.enumerablerandomextension.md)                                         | Contains extension methods for ``System.Collections.Generic.IEnumerable`1`` .                                                                              |
| [FirstSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.firstsaliencystrategy.md)                                                 | A content saliency strategy that always returns the first non-failing item in the list of available options.                                               |
| [RandomBestLeastRecentlyViewedSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.randombestleastrecentlyviewedsaliencystrategy.md) | A content saliency strategy that returns a random choice of the best, least-recently seen choices from the provided options.                               |

## Enums

| Name                                                                                                | Description                                                                                                                            |
| --------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------- |
| [ContentSaliencyContentType](/api/csharp/yarn.saliency/yarn.saliency.contentsaliencycontenttype.md) | Indicates what type of content a [ContentSaliencyOption](/api/csharp/yarn.saliency/yarn.saliency.contentsaliencyoption.md) represents. |

## Interfaces

| Name                                                                                            | Description                                                                    |
| ----------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------ |
| [IContentSaliencyStrategy](/api/csharp/yarn.saliency/yarn.saliency.icontentsaliencystrategy.md) | Contains methods for choosing a piece of content from a collection of options. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/api/csharp/yarn.saliency.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
